/* VRANK pattern matching suite
 * Copyright (C) 1996 to Justin Zobel
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * See Copyright.txt for further details. */


/* Hash a string to a number >= 0 and < upper_bound. The field name is used
   to hash into the value so the same string in different fields hash to 
   different values. */

#include "def.h"

int
wordhash(char *word, int seed, int upper_bound)
{
    int hashval, i, length;

    length = strlen(word);

    for( hashval=seed ; length ; length-- )
	hashval = (hashval << 5) - hashval + *word++;
    if(hashval < 0 )
	hashval = -hashval;

    return( hashval % upper_bound );
}
