/* VRANK pattern matching suite
 * Copyright (C) 1996 to Justin Zobel
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * See Copyright.txt for further details. */


#include <stdio.h>
#ifdef SOLARIS
#include <string.h>
#else /* SOLARIS */
#include <strings.h>
#endif /* SOLARIS */

#define true		1
#define false		0

#define STRLEN		60

int	lcs(char *, char *);
static int max3(int,int,int);
static char isequal(char,char);

int	init = false;

/* Longest common subsequence */
int
lcs(char *in1, char *in2)
{
    int		F[STRLEN+1][STRLEN+1];
    int		i, j, l1, l2;

    l1 = strlen(in1);
    l2 = strlen(in2);

    if( !init )
    {
	for( i=0 ; i<=STRLEN ; i++ )
	    F[0][i] = F[i][0] = 0;
	init = true;
    }

    for( i=1 ; i<=l1 ; i++ )
	for( j=1 ; j<=l2 ; j++ )
	    F[i][j] = max3(F[i-1][j],
			      F[i][j-1],
			      F[i-1][j-1] + isequal(in1[i-1], in2[j-1]));
    
    return((int) F[l1][l2]);
}


int
max3(int a, int b, int c)
{
    if( a < b )
	return( ( c < b ) ? b : c );
    else
	return( ( c < a ) ? a : c );
}


char
isequal(char c1, char c2)
{
    return( ( c1 == c2 ) ? 1 : 0 );
}
