/* VRANK pattern matching suite
 * Copyright (C) 1996 to Justin Zobel
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * See Copyright.txt for further details. */


#include <stdio.h>

main(int argc, char *argv[])
{
	/* #1: collection, #2: bytes of index, #3: n, #4: blocking factor */

    int		size;			/* of inv lists in bytes */
    int		n;			/* gram length */
    int		grams;			/* distinct grams */
    int		bf;			/* block factor */
    double	log(), ceil();
    double	ptrs;			/* size of array of ptrs to words */
    double	lp;			/* size of array of ptrs to inv lists */

    if( argc != 5 )
    {
	fprintf(stderr, "Usage: sizes coll inv-size n blockfac\n");
	exit(1);
    }

    size = atoi(argv[2]);
    n = atoi(argv[3]);
    bf = atoi(argv[4]);
    lp = ceil( log( (double) size )/log(2.0) )/8;

    if( *argv[1] == 't' )		/* trec */
    {
	if( n==0 )
	    grams = 0;
	else if( n==2 )
	    grams = 2794;
	else if( n==3 )
	    grams = 69137;
	else if( n==4 )
	    grams = 441299;
	else
	    grams = -1000000;

	ptrs = 1073727.0/(double)bf * ceil( log( 10171325.0 )/log(2.0) )/8;
	printf("%1.3f (ptrs %1.3f)\n",
		( size + (n+lp)*grams + ptrs ) / 101713.25, ptrs / 101713.25);
    }
    else if( *argv[1] == 'm' )		/* macq */
    {
	if( n==0 )
	    grams = 0;
	else if( n==2 )
	    grams = 620;
	else if( n==3 )
	    grams = 7005;
	else if( n==4 )
	    grams = 37631;
	else
	    grams = -1000000;

	ptrs = 58164.0/(double)bf * ceil( log( 550151.0 )/log(2.0) )/8;
	printf("%1.3f (ptrs %1.3f)\n",
		( size + (n+lp)*grams + ptrs ) / 5501.51, ptrs / 5501.51);
    }
    else if( *argv[1] == 'b' )		/* bible */
    {
	if( n==0 )
	    grams = 0;
	else if( n==2 )
	    grams = 920;
	else if( n==3 )
	    grams = 6204;
	else if( n==4 )
	    grams = 19212;
	else
	    grams = -1000000;

	ptrs = 13688.0/(double)bf * ceil( log( 109716.0 )/log(2.0) )/8;
	printf("%1.3f (ptrs %1.3f)\n",
		( size + (n+lp)*grams + ptrs ) / 1097.16, ptrs / 1097.16);
    }
    else if( *argv[1] == 'n' )		/* names */
    {
	if( n==0 )
	    grams = 0;
	else if( n==2 )
	    grams = 664;
	else if( n==3 )
	    grams = 7855;
	else if( n==4 )
	    grams = 39660;
	else
	    grams = -1000000;

	ptrs = 31763.0/(double)bf * ceil( log( 247815.0 )/log(2.0) )/8;
	printf("%1.3f (ptrs %1.3f)\n",
		( size + (n+lp)*grams + ptrs ) / 2478.15, ptrs / 2478.15);
    }
    else if( *argv[1] == 'i' )		/* ispell */
    {
	if( n==0 )
	    grams = 0;
	else if( n==2 )
	    grams = 1292;
	else if( n==3 )
	    grams = 10235;
	else if( n==4 )
	    grams = 47675;
	else
	    grams = -1000000;

	ptrs = 113212.0/(double)bf * ceil( log( 1141182.0 )/log(2.0) )/8;
	printf("%1.3f (ptrs %1.3f)\n",
		( size + (n+lp)*grams + ptrs ) / 11411.82, ptrs / 11411.82);
    }

    exit(0);
}
