/* VRANK pattern matching suite
 * Copyright (C) 1996 to Alistair Moffat
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * See Copyright.txt for further details. */


/*
 *------------------------------------------------------------
 *
 *	File..........:	@(#)dkq.c	1.2 6/1/92
 *	Purpose.......:	z
 *	Author........:	Gary Eddy (eddy@cs.mu.OZ.AU)
 *	Date..........: 2/3/92
 *
 *	Description:
 *		z
 *
 *	Contents:
 *		sort, dosort, insort
 *
 *------------------------------------------------------------
 */

#include	<stdio.h>
#include	<stdlib.h>

#define		fdemand(fact, remark)\
		{if (!(fact)) { fprintf(stderr, "%s\n", remark); exit(1); } }

#define 	CUTOFF	10

char	*sort_name = "detatched key quicksort";

static char	*SCCS_Id = "@(#)dkq.c	1.2 6/1/92";

void	dosort();
void	insort();

/*
 *	sort():
 *		y
 *
 *	Accesses outside variables:	y
 *
 *	Return value...:		y
 */

sort(A, n, size, cmp)
char *A;
int n, size, (*cmp)();
{
	char	**B;
	int	next, curr;
	char	*crnt, *item;;

	fdemand(B = (char **) malloc(n*sizeof(char *)),
		"Couldn't get memory\n");
	B[0] = A;
	for(curr = 1; curr < n; curr++)
		B[curr] = B[curr-1]+size;
	dosort(B, B+n-1, cmp);
	insort(B, n, cmp);
	/* now do in-place permutation of A */

	item = (char *)malloc(size);
	for (next=0; next<n; next++) {
		char *datacurr, *dataleftcurr, *final;
		float fsize=(float)size;
		int prnt;
		if (B[next] == NULL)
			continue;
		curr = next;
		final = datacurr = A+(int)(fsize*curr);
		memcpy(item, datacurr, size);
		while (B[curr] != final) {
			dataleftcurr = B[curr];
			memcpy(datacurr, dataleftcurr, size);
			prnt = curr;
			curr = (int)((float)((int)B[curr]-(int)A)/fsize);
			B[prnt] = NULL;
			datacurr = dataleftcurr;
		}
		memcpy(datacurr, item, size);
		B[curr] = NULL;
	}
	free(item);
#ifdef IGNORE
	{
		int i, *p = (int *)A;;
		for (i=0; i<n; i++)
			*p++ = i;
	}
#endif
	free(B);
} /* sort() */


/*
 *	dosort():
 *		y
 *
 *	Accesses outside variables:	y
 *
 *	Return value...:		y
 */

void 
dosort(L, R, cmp)
char	**L, **R;
int	(*cmp)();
{
	register char	**l = L, **r = R;
	int	num;
	char	*item, *tmp;

	srand(10538);

	for(;(num = r - l) > CUTOFF;) {
		item = l[rand()%num];
		for( ; l<=r ; ) {
			while (cmp(*l, item) < 0) l++;
			while (cmp(item, *r) < 0) r--;
			if (l<=r) {
				tmp = *l;
				*l++ = *r;
				*r-- = tmp;
			}
		}
		if((r - L) < (R - l)) {
			dosort(L, r, cmp);
			r = R;
			L = l;
		}
		else {
			dosort(l, R, cmp);
			l = L;
			R = r;
		}
	}
} /* dosort() */

/*
 *      insort():
 *              z
 *
 *      Accesses outside variables:     z
 *
 *      Return value...:                z
 */

void
insort(buf, num, comp)
char    **buf;
int     num; int     (*comp)();
{
        int     j, i;
        char    **end = buf + num;
	char	*elem;
	char	**curr;
	char	**frst = buf + 1;

        for(; frst < end; frst++)
                if( comp(*frst, *(frst-1)) < 0) {
			elem = *(curr = frst);
			for (;curr > buf && comp(*(curr-1), elem) > 0; curr--) 
				*curr = *(curr -1);
			*curr = elem;
		}
        return;
} /* insort() */
